﻿using System;
using System.Runtime.InteropServices;
using System.Windows;

namespace WpfWVVMSample
{
    public partial class AppHmInterface
    {
        public static Window wpfWindow;

        public static IntPtr CreateForm()
        {
            if (wpfWindow != null)
            {
                wpfWindow.Close();
                wpfWindow = null;
            }

            wpfWindow = new MainView();
            var vm = new MainViewModel();
            wpfWindow.DataContext = vm;
            wpfWindow.Show();
            return (IntPtr)1;
        }

        // 秀丸のバージョンで引数が渡ってくるものと渡ってこないものがあるので、
        // 両対応にするためデフォルト引数の0が必要。
        public static IntPtr OnDetachMethod(IntPtr reason)
        {
            // 秀丸エディタが閉じられる前に実行されるコード
            // このWPFアプリケーションを終了します。
            if (wpfWindow != null)
            {
                wpfWindow.Close();
                wpfWindow = null;

                // このメソッドが通過したことをわかりやすくするため、終了理由の番号をダイアログボックスで表示
                MessageBox.Show("OnDetachMethod");
            }

            return (IntPtr)0;
        }
    }
}
